/* CD Lycee Fourcade 13120 Gardanne 11/2009 */
/* Demo SPI sur DAC MICROCHIP MCP4821
DAC 12 bits
protocole (datasheet page 17)
CS=0
emission poids forts (4 bits D3 D2 D1 D0), 
bit 7,5=0 bit 4=0 (/GA, gain X2) bit 3=1 (/SHDN)
emission poids faibles (8 bits)
CS=1
*/

#include <p18f2620.h>

#define CS PORTCbits.RC2
#define TRIS_CS TRISCbits.TRISC2


void initSPI_emission(void)  // initialisise SPI sur PIC18
{
DDRCbits.RC3=0;	//SCK en sortie
DDRCbits.RC5=0;	//SDO en sortie 
SSPSTAT=0b01000000; //echantillonne au milieu de la donne, sur front montant
SSPCON1=0b00100000;	// active SPI MASTER, IDLE=0, clock=FOSC/4
PIR1bits.SSPIF=0;	// efface drapeau d'emission SSPIF 
TRIS_CS=0 ; // signal CS
CS=1;

}

void emet_SPI(unsigned int n)   // envoie synchro, pouls et spo2
{
unsigned char forts,faibles;
		forts=n>>8;		// recupere poids forts
		faibles=n|0x0F;	// recupere poids faibles
		CS=0;		// debut transmission
		forts|=0b00010000; // Sortie MCP4821 activee G=2
//		forts|=0b00110000; // Sortie MCP4821 activee G=1
		SSPBUF=forts;			 
		while(!PIR1bits.SSPIF);	// attend la fin de l'mission
		PIR1bits.SSPIF=0;
		SSPBUF=faibles;				// emmision 
		while(!PIR1bits.SSPIF); // attend la fin de l'mission
		PIR1bits.SSPIF=0;
		CS=1;		// fin transmission, d=buffer en sortie du MCP4821
}

void main(void)
{unsigned int a;

	init_horloge_interne();
	initSPI_emission();
	while(1)	// demo, generateur de rampes
		{
			for (a=0;a<=4095;a+=10)
				{
						emet_SPI(a);
				}
		}


}